unit Unit6;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,
  FMX.StdCtrls, FMX.Objects, FMX.Colors, FMX.Graphics,
  UnitF, FMX.Controls.Presentation;

type
  TForm6 = class(TForm)
    StatusBar1: TStatusBar;
    Button1: TButton;
    Button2: TButton;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    ColorBox1: TColorBox;
    procedure FormShow(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure PaintBox1DblClick(Sender: TObject);
  private
    { private 錾 }
  public
    { public 錾 }
    ColVal : Cardinal;
    ColNam : string;
  end;

  TColorSet = record
    col : Cardinal;
    nam : string;
  end;

const
   ColorSets : array[0..139] of TColorSet = (
      (col:($fff0f8ff); nam:('aliceblue')),
      (col:($fffaebd7); nam:('antiquewhite')),
      (col:($ff00ffff); nam:('aqua')),
      (col:($ff7fffd4); nam:('aquamarine')),
      (col:($fff0ffff); nam:('azure')),
      (col:($fff5f5dc); nam:('beige')),
      (col:($ffffe4c4); nam:('bisque')),
      (col:($ff000000); nam:('black')),
      (col:($ffffebcd); nam:('blanchedalmond')),
      (col:($ff0000ff); nam:('blue')),
      (col:($ff8a2be2); nam:('blueviolet')),
      (col:($ffa52a2a); nam:('brown')),
      (col:($ffdeb887); nam:('burlywood')),
      (col:($ff5f9ea0); nam:('cadetblue')),

      (col:($ff7fff00); nam:('chartreuse')),
      (col:($ffd2691e); nam:('chocolate')),
      (col:($ffff7f50); nam:('coral')),
      (col:($ff6495ed); nam:('cornflowerblue')),
      (col:($fffff8dc); nam:('cornsilk')),
      (col:($ffdc143c); nam:('crimson')),
      (col:($ff00ffff); nam:('cyan')),
      (col:($ff00008b); nam:('darkblue')),
      (col:($ff008b8b); nam:('darkcyan')),
      (col:($ffb8860b); nam:('darkgoldenrod')),
      (col:($ffa9a9a9); nam:('darkgray')),
      (col:($ff006400); nam:('darkgreen')),
      (col:($ffbdb76b); nam:('darkkhaki')),
      (col:($ff8b008b); nam:('darkmagenta')),

      (col:($ff556b2f); nam:('darkolivegreen')),
      (col:($ffff8c00); nam:('darkorange')),
      (col:($ff9932cc); nam:('darkorchid')),
      (col:($ff8b0000); nam:('darkred')),
      (col:($ffe9967a); nam:('darksalmon')),
      (col:($ff8fbc8f); nam:('darkseagreen')),
      (col:($ff483d8b); nam:('darkslateblue')),
      (col:($ff2f4f4f); nam:('darkslategray')),
      (col:($ff00ced1); nam:('darkturquoise')),
      (col:($ff9400d3); nam:('darkviolet')),
      (col:($ffff1493); nam:('deeppink')),
      (col:($ff00bfff); nam:('deepskyblue')),
      (col:($ff696969); nam:('dimgray')),
      (col:($ff1e90ff); nam:('dodgerblue')),

      (col:($ffb22222); nam:('firebrick')),
      (col:($fffffaf0); nam:('floralwhite')),
      (col:($ff228b22); nam:('forestgreen')),
      (col:($ffff00ff); nam:('fuchsia')),
      (col:($ffdcdcdc); nam:('gainsboro')),
      (col:($fff8f8ff); nam:('ghostwhite')),
      (col:($ffffd700); nam:('gold')),
      (col:($ffdaa520); nam:('goldenrod')),
      (col:($ff808080); nam:('gray')),
      (col:($ff008000); nam:('green')),
      (col:($ffadff2f); nam:('greenyellow')),
      (col:($fff0fff0); nam:('honeydew')),
      (col:($ffff69b4); nam:('hotpink')),
      (col:($ffcd5c5c); nam:('indianred')),

      (col:($ff4b0082); nam:('indigo')),
      (col:($fffffff0); nam:('ivory')),
      (col:($fff0e68c); nam:('khaki')),
      (col:($ffe6e6fa); nam:('lavender')),
      (col:($fffff0f5); nam:('lavenderblush')),
      (col:($ff7cfc00); nam:('lawngreen')),
      (col:($fffffacd); nam:('lemonchiffon')),
      (col:($ffadd8e6); nam:('lightblue')),
      (col:($fff08080); nam:('lightcoral')),
      (col:($ffe0ffff); nam:('lightcyan')),
      (col:($fffafad2); nam:('lightgoldenrodyellow')),
      (col:($ff90ee90); nam:('lightgreen')),
      (col:($ffd3d3d3); nam:('lightgray')),
      (col:($ffffb6c1); nam:('lightpink')),

      (col:($ffffa07a); nam:('lightsalmon')),
      (col:($ff20b2aa); nam:('lightseagreen')),
      (col:($ff87cefa); nam:('lightskyblue')),
      (col:($ff778899); nam:('lightslategray')),
      (col:($ffb0c4de); nam:('lightsteelblue')),
      (col:($ffffffe0); nam:('lightyellow')),
      (col:($ff00ff00); nam:('lime')),
      (col:($ff32cd32); nam:('limegreen')),
      (col:($fffaf0e6); nam:('linen')),
      (col:($ffff00ff); nam:('magenta')),
      (col:($ff800000); nam:('maroon')),
      (col:($ff66cdaa); nam:('mediumaquamarine')),
      (col:($ff0000cd); nam:('mediumblue')),
      (col:($ffba55d3); nam:('mediumorchid')),

      (col:($ff9370db); nam:('mediumpurple')),
      (col:($ff3cb371); nam:('mediumseagreen')),
      (col:($ff7b68ee); nam:('mediumslateblue')),
      (col:($ff00fa9a); nam:('mediumspringgreen')),
      (col:($ff48d1cc); nam:('mediumturquoise')),
      (col:($ffc71585); nam:('mediumvioletred')),
      (col:($ff191970); nam:('midnightblue')),
      (col:($fff5fffa); nam:('mintcream')),
      (col:($ffffe4e1); nam:('mistyrose')),
      (col:($ffffe4b5); nam:('moccasin')),
      (col:($ffffdead); nam:('navajowhite')),
      (col:($ff000080); nam:('navy')),
      (col:($fffdf5e6); nam:('oldlace')),
      (col:($ff808000); nam:('olive')),

      (col:($ff6b8e23); nam:('olivedrab')),
      (col:($ffffa500); nam:('orange')),
      (col:($ffff4500); nam:('orangered')),
      (col:($ffda70d6); nam:('orchid')),
      (col:($ffeee8aa); nam:('palegoldenrod')),
      (col:($ff98fb98); nam:('palegreen')),
      (col:($ffafeeee); nam:('paleturquoise')),
      (col:($ffdb7093); nam:('palevioletred')),
      (col:($ffffefd5); nam:('papayawhip')),
      (col:($ffffdab9); nam:('peachpuff')),
      (col:($ffcd853f); nam:('peru')),
      (col:($ffffc0cb); nam:('pink')),
      (col:($ffdda0dd); nam:('plum')),
      (col:($ffb0e0e6); nam:('powderblue')),

      (col:($ff800080); nam:('purple')),
      (col:($ffff0000); nam:('red')),
      (col:($ffbc8f8f); nam:('rosybrown')),
      (col:($ff4169e1); nam:('royalblue')),
      (col:($ff8b4513); nam:('saddlebrown')),
      (col:($fffa8072); nam:('salmon')),
      (col:($fff4a460); nam:('sandybrown')),
      (col:($ff2e8b57); nam:('seagreen')),
      (col:($fffff5ee); nam:('seashell')),
      (col:($ffa0522d); nam:('sienna')),
      (col:($ffc0c0c0); nam:('silver')),
      (col:($ff87ceeb); nam:('skyblue')),
      (col:($ff6a5acd); nam:('slateblue')),
      (col:($ff708090); nam:('slategray')),

      (col:($fffffafa); nam:('snow')),
      (col:($ff00ff7f); nam:('springgreen')),
      (col:($ff4682b4); nam:('steelblue')),
      (col:($ffd2b48c); nam:('tan')),
      (col:($ff008080); nam:('teal')),
      (col:($ffd8bfd8); nam:('thistle')),
      (col:($ffff6347); nam:('tomato')),
      (col:($ff40e0d0); nam:('turquoise')),
      (col:($ffee82ee); nam:('violet')),
      (col:($fff5deb3); nam:('wheat')),
      (col:($ffffffff); nam:('white')),
      (col:($fff5f5f5); nam:('whitesmoke')),
      (col:($ffffff00); nam:('yellow')),
      (col:($ff9acd32); nam:('yellowgreen'))
   );

var
  Form6: TForm6;

implementation

{$R *.fmx}

// N
procedure TForm6.FormShow(Sender: TObject);
begin
   ColVal := ColorSets[0].col;
   ColNam := ColorSets[0].nam;
   ColorBox1.Color:= ColVal;
   Label1.Text    := ColNam;
   Button1.SetFocus;
end;

// ʕ\
procedure TForm6.PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
var
   sx,sy,px,py : Single;
   i,j:integer;
begin
   sx := PaintBox1.Width;
   sy := PaintBox1.Height;
   px := sx / 10;
   py := sy / 14;
   with Canvas do begin
      BeginScene;
      clear($FFFFFFFF);
      Font.Size := 10;
      for j:=0 to 13 do begin
         for i:=0 to 9 do begin
            Fill.Color := ColorSets[i+j*10].col;
            FillRect(RectF(i*px,j*py, (i+1)*px-1,(j+1)*py-11),0,0,[],1.0);
            Fill.Color := $FF000000;
            FillText(RectF(i*px,(j+1)*py-11, (i+1)*px-1,(j+1)*py-1), ColorSets[i+j*10].nam,
               false, 100, [TFillTextFlag.RightToLeft], TTextAlign.Center, TTextAlign.Center);
         end;
      end;
      EndScene;
   end;
end;

// }EXw莞
procedure TForm6.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
   sx,sy,px,py : Single;
   n : integer;
begin
   sx := PaintBox1.Width;
   sy := PaintBox1.Height;
   px := sx / 10;
   py := sy / 14;
   n  := Trunc(X/px) + Trunc(Y/py)*10;
   if (n <   0) then n :=   0;
   if (n > 139) then n := 139;
   ColVal := ColorSets[n].col;
   ColNam := ColorSets[n].nam;
   ColorBox1.Color:= ColVal;
   Label1.Text    := ColNam;
end;

procedure TForm6.PaintBox1DblClick(Sender: TObject);
begin
   ModalResult := mrOK;
end;

end.
