unit UnitF;

interface

uses
   System.SysUtils, System.Types,
   {$IFDEF MSWINDOWS}
      Winapi.ShellAPI, Winapi.Windows,
   {$ENDIF MSWINDOWS}
   {$IFDEF MACOS}
      Macapi.CoreFoundation, Posix.Unistd,
      Posix.Stdlib,
   {$ENDIF MACOS}
   System.Math;

type
  TMisc = class
    class procedure Open(sCommand,sPara: string);
  end;

{ϊ֐}
   function SBool(s:string): Boolean;
   function BStr(f:Boolean): string;
   function SInt(S:string) : Integer;
   function IStr(i:Integer): string;
   function SDbl(S:string) : double;
   function DStr(V:double) 		     : string; overload;
   function DStr(V1:double;V2:integer): string; overload;
{֐FTStringHelpergp֐ }
   function StrChar(s:string; N:integer) : String;
   function StrUpp(s:string) : string;
   function StrLow(s:string) : string;
   function StrRep(ss,sd,s:string) : string;
   function InStr(ss,s:string) : integer; overload;
   function InStr(ss,s:string;st:integer) : integer; overload;
   function InStrL(ss,s:string) : integer;
   function StrCountSpace(s:string) : integer;
   function StrSpaces(n:integer) : string;
   function StrSpaceTab(s:string) : string;
   function StrSub(s:string;v1:integer)   : string; overload;
   function StrSub(s:string;v1,v2:integer): string; overload;
   function StrRight(s:string;v1:integer): string;
   function ChkFileName(fn:string) : Boolean;
   function  RGB(r,g,b:integer) : Cardinal; overload;
   function  RGB(col:Cardinal) : string; overload;
   procedure RGB(col:Cardinal;var r,g,b:integer); overload;
   procedure ExecApp(fn,ps:string);

implementation

class procedure TMisc.Open(sCommand,sPara: string);
begin
   {$IFDEF MSWINDOWS}
      ShellExecute(0, 'OPEN', PChar(sCommand), PChar(sPara), '', SW_SHOWNORMAL);
   {$ENDIF MSWINDOWS}
   {$IFDEF MACOS}
      {$IFNDEF IOS}
         _system(PAnsiChar('open ' + AnsiString(sCommand+' '+sPara)));
      {$ENDIF IOS}
   {$ENDIF MACOS}
end;

// ----------
//  ϊ֐
// ----------

// 񁨃u[A
function SBool(s:string):Boolean;
var
   ss : string ;
begin
   Result := False;
   ss := s.ToUpper;
   if (ss = 'T')or(ss = 'TR')or(ss = 'TRU')or(ss = 'TRUE')
    or(ss = '1')or(ss = 'P')or(ss = '')or(ss = 'ON')
    or(ss = '^')or(ss = '') then
      Result := True;
end;

// u[Ai'0'or'1'j
function BStr(f:Boolean):string;
begin
   if (f) then
      Result := '1'
   else
      Result := '0';
end;

// 𐮐lɕϊ
function SInt(S:string) : Integer;
var
	i,j : Integer;
begin
	if (S = '') then
   	i := 0
   else begin
      Val(S,i,j);
      if (j <> 0) then i := 0;
   end;
   Result := i;
end;

// l𕶎ɕϊ
function IStr(i:Integer): string;
begin
   Result := IntToStr(i);
end;

// lɕϊ
function SDbl(S:string) : double;
var
	j : Integer;
	w : double;
begin
	if (S = '') then
   	w := 0.0
   else begin
      Val(S,w,j);
      if (j <> 0) then w := 0.0;
   end;
   Result := w;
end;

// l𕶎ɕϊ
//  in : V1 : l
function DStr(V:double) : string;
begin
   Result := FloatToStr(V);
end;

// l𕶎ɕϊ
//  in : V1 : l
//       V2 : _ȉ
function DStr(V1:double;V2:integer) : string;
var
   s : string;
begin
   s := '%.' + IntToStr(V2) + 'f';
   Result := Format(s,[V1]);
end;

// ---------------------------------
//  ֐FTStringHelpergp֐
// ---------------------------------

// ̂P擾
//    N : 0 ` Len-1
//    Nl̃`FbN͂Ȃ̂Œ
function StrChar(s:string; N:integer) : String;
begin
   Result := s.Chars[N];
end;

// 啶ɕϊ
function StrUpp(s:string) : string;
begin
   Result := s.ToUpper;
end;

// ɕϊ
function StrLow(s:string) : string;
begin
   Result := s.ToLower;
end;

// ̕u
//    ss : 
//    sd : V
//    s  ; 
// (ret)
//    uꂽ
function StrRep(ss,sd,s:string) : string;
begin
   Result := s.Replace(ss,sd);
end;

// Ɏw蕶񂪂邩ǂmF  pos()Ɠ
//    ss : w蕶
//    s : 
// ret
//    -1:Ȃ@0` ڂ
function InStr(ss,s:string) : integer;
begin
   Result := s.IndexOf(ss);
end;

// Ɏw蕶񂪂邩ǂmF
//    ss : w蕶
//    s  : 
//    st : Jnindex
// ret
//    -1:Ȃ@0` ڂ
function InStr(ss,s:string;st:integer) : integer;
begin
   Result := s.IndexOf(ss,st);
end;

// Ɏw蕶񂪂邩ǂmF  납JEg
//    ss : w蕶
//    s : 
// ret
//    -1:Ȃ@0` ڂ
function InStrL(ss,s:string) : integer;
var
   i,j : integer;
begin
   j := -1;
   for i:=0 to s.Length-1 do
      if (s.Chars[i] = ss) then j := i;
   Result := j;
end;

// ̐擪甼p󔒂JEg
//    s : 
function StrCountSpace(s:string) : integer;
var
   i,j : integer;
begin
   j := 0;
   for i:=0 to s.Length-1 do begin
      if (s.Chars[i] = ' ') then
         Inc(j)
      else
         break;
   end;
   Result := j;
end;

// w蕶̔p󔒂̕Ԃ
//    n : 
function StrSpaces(n:integer) : string;
var
   i : integer;
   s : string;
begin
   s := '';
   for i:=1 to n do
      s := s + ' ';
   Result := s;
end;

// ̐擪A锼p󔒖TABR[hԂ
//    s : 
function StrSpaceTab(s:string) : string;
var
   i : integer;
   r : string;
begin
   r := '';
   for i:=0 to s.Length-1 do begin
      if (s.Chars[i] = ' ')or(s.Chars[i] = #9) then
         r := r + s.Chars[i]
      else
         break;
   end;
   Result := r;
end;

// ̈ꕔo
//    v1 : ʒu(0-)
function StrSub(s:string;v1:integer): string;
begin
   Result := s.Substring(v1);
end;

// ̈ꕔo
//    v1 : ʒu(0-)
//    v2 : 
function StrSub(s:string;v1,v2:integer): string;
begin
   Result := s.Substring(v1,v2);
end;

// ̈ꕔE(Ԍ)o
//    v1 : 
function StrRight(s:string;v1:integer): string;
var
   i : integer;
begin
   i := s.Length - v1;
   if (i < 0) then i := 0;
   Result := s.Substring(i,v1);
end;

// t@C̃`FbN
//@@t@CɎg镶
//    @@pi 0 ` 9 jApi a ` z j
//    @@sIhi . jAnCti - jAA_[XRAi _ j
//    fn : t@CAtpXt@CipX̃`FbN͍sȂj
// (ret)
//    True : OK
//    False: NG
function ChkFileName(fn:string) : Boolean;
var
   i : integer;
   s : string;
begin
   Result := True;
   fn := ExtractFileName(fn);
   if (fn = '')or(fn = '.')or(fn = '..') then Result := False;
   for i:=0 to Length(fn)-1 do begin
      s := StrChar(fn,i);
      if (s >= '0')and(s <= '9')
       or(s >= 'a')and(s <= 'z')
       or(s  = '.')or(s  = '_')or(s  = '-') then
      else begin
         Result := False;
         break;
      end;
   end;
end;

// R,G,BlFl擾
function RGB(r,g,b:integer) : Cardinal;
begin
   Result := ($FF shl 24) + (r shl 16) + (g shl 8) + b;
end;

// Fl𕶎ɕϊ (AlARGB)
function RGB(col:Cardinal) : string;
var
   r,g,b:integer;
begin
   RGB(col,r,g,b);
   Result := StrLow(IntToHex(r,2)+IntToHex(g,2)+IntToHex(b,2));
end;

// Fl R,G,Bl擾
procedure RGB(col:Cardinal;var r,g,b:integer);
begin
   r := (col div 65536) mod 256;
   g := (col div 256)   mod 256;
   b :=  col mod 256;
end;

// AvP[Vs
procedure ExecApp(fn,ps:string);
begin
   if FileExists(fn) then begin
      try
         TMisc.Open('"'+fn+'"', '"'+ps+'"');
      except
         ;
      end;
   end;
end;

end.
